#if !defined DOC_OBJ_H
#define DOC_OBJ_H

#include "DispObjects.h"
#include "objmodel\\appauto.h"
#include "objmodel\\appguid.h"
#include "objmodel\\textauto.h"
#include "objmodel\\textguid.h"

// [id(0x0000000d), propget, helpstring("Returns the active Document object.")]
// HRESULT _stdcall ActiveDocument([out, retval] IDispatch** ActiveDocument);

class SActiveDocument: public DispObject
{
public:
    SActiveDocument (SObjFace<IApplication, &IID_IApplication> & app)
    {
        HRESULT hr = app->get_ActiveDocument (&_iDisp);
        if (FAILED (hr))
            throw HEx (hr, "get_ActiveDocument failed");
    }
};

class SSelection: public DispObject
{
public:
    SSelection (SObjFace<ITextDocument, &IID_ITextDocument> & doc)
    {
        HRESULT hr = doc->get_Selection (&_iDisp);
        if (FAILED (hr))
            throw HEx (hr, "get_Selection failed");
    }
};

#endif